/*
 * FIRA2 is a program to inject/hide a file into a standard bitmap file. 
 * It includes file compression and encryption as well.
 * Copyright (C) 2006 LCC Coprs
 * The author can be reached at aurora.lai@gmail.com
 *
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free Software 
 * Foundation; either version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */


/*
 * FILE : LookAndFeel.java
 * PURPOSE : to set the Look and Feel (L&F) of the GUI program
 * TAKEN FROM: Swing: A Quick Tutorial for AWT Programmers -> 
 *             Changing the Look and Feel -> WindowUtilities.java
 *
 */


package gui;

import javax.swing.UIManager;


public class LookAndFeel
{
  // set L&F to Windows L&F
  public static void setWindowLookAndFeel ()
  {
    try {
      UIManager.setLookAndFeel (UIManager.getSystemLookAndFeelClassName ());
    } catch (Exception e) {
      System.out.println ("Error setting native L & F: " +e);
    }
  }

  // set to Java L&F
  public static void setJavaLookAndFeel ()
  {
    try {
      UIManager.setLookAndFeel (UIManager.getCrossPlatformLookAndFeelClassName ());
    } catch (Exception e) {
      System.out.println ("Error setting native L & F: " +e);
    }
  }

  // set to Motif L&F
  public static void setMotifLookAndFeel ()
  {
    try {
      UIManager.setLookAndFeel ("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
    } catch (Exception e) {
      System.out.println ("Error setting native L & F: " +e);
    }
  }
}