/*
 * FIRA2 is a program to inject/hide a file into a standard bitmap file. 
 * It includes file compression and encryption as well.
 * Copyright (C) 2006 LCC Coprs
 * The author can be reached at aurora.lai@gmail.com OR
 *   at: 9B, Lorong Merdeka 15, 96000 Sibu, Sarawak, Malaysia
 *
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free Software 
 * Foundation; either version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

/* 
 * FILE: MainFrame.java
 * INHERITS: JFrame
 * PURPOSE: to create and layout the overall GUI components for the whole program
 * AUTHOR: LCC Coprs
 * COMMENT: This file is generated by NetBean IDE 4.0, and is modified by the 
 *          specified author to customize some of the features
 *
 * Created on June 18, 2006, 3:10 PM
 */

package gui;

import javax.swing.JOptionPane;
import javax.swing.ImageIcon;
import sys.*;

/**
 *
 * @author  LCC Corps
 */
public class MainFrame extends javax.swing.JFrame {
    // Global variable used to prohibit application closing while there is running task.
    // This variable is being modified in "Inject" button action handler in InjectPanel.java, 
    // by "Retrieve" button action handler in RetrievePanel.java and by "Exit" button handler in AboutPanel.java
    public static int taskInProgress = 0;
    
    /** Creates new form MainFrame */
    public MainFrame() {
        LookAndFeel.setWindowLookAndFeel ();
        initComponents();
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        tabPane = new javax.swing.JTabbedPane();
        aboutPanel1 = new gui.AboutPanel();
        injectPanel1 = new gui.InjectPanel();
        retrievePanel1 = new gui.RetrievePanel();
        jMenuBar1 = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        aboutItem = new javax.swing.JMenuItem();
        exitItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
        setTitle("FIRA v2.0");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setLocationByPlatform(true);
        setName("mainFrame");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                MainFrame.this.windowClosing(evt);
            }
        });

        tabPane.setBorder(new javax.swing.border.EtchedBorder());
        tabPane.addTab("About", new javax.swing.ImageIcon(getClass().getResource("/gui/images/aboutTab.gif")), aboutPanel1);

        tabPane.addTab("Inject", new javax.swing.ImageIcon(getClass().getResource("/gui/images/injectTab.gif")), injectPanel1);

        tabPane.addTab("Retrieve", new javax.swing.ImageIcon(getClass().getResource("/gui/images/retrieveTab.gif")), retrievePanel1);

        getContentPane().add(tabPane, java.awt.BorderLayout.CENTER);

        fileMenu.setMnemonic('f');
        fileMenu.setText("File");
        fileMenu.setName("fileMenu");
        fileMenu.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                fileMenuActionPerformed(evt);
            }
        });

        aboutItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_A, java.awt.event.InputEvent.ALT_MASK));
        aboutItem.setMnemonic('a');
        aboutItem.setText("About");
        aboutItem.setToolTipText("Brief info about this application");
        aboutItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutItemActionPerformed(evt);
            }
        });

        fileMenu.add(aboutItem);

        exitItem.setAccelerator(javax.swing.KeyStroke.getKeyStroke(java.awt.event.KeyEvent.VK_X, java.awt.event.InputEvent.ALT_MASK));
        exitItem.setMnemonic('x');
        exitItem.setText("Exit");
        exitItem.setToolTipText("Exit this application");
        exitItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitItemActionPerformed(evt);
            }
        });

        fileMenu.add(exitItem);

        jMenuBar1.add(fileMenu);
        fileMenu.getAccessibleContext().setAccessibleName("fileMenu");

        setJMenuBar(jMenuBar1);

        pack();
    }//GEN-END:initComponents

    private void fileMenuActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_fileMenuActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_fileMenuActionPerformed

    private void windowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_windowClosing
        // TODO add your handling code here:
        exitItemActionPerformed (null);
    }//GEN-LAST:event_windowClosing

    private void aboutItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutItemActionPerformed
        // TODO add your handling code here:
        JOptionPane.showMessageDialog (this,
                "         FIRA v2 - File Injection and Retrieval Application.\n" +
                "         An application to hide a file inside a standard bitmap file.\n\n" +
                "              Author: LCC Corps\n" +
                "              Version: 2.0\n" +
                "              Dedicated to: mY anGel\n\n" +
                "===============================================================\n\n" +
                "FIRA2 version 2.0, Copyright (C) 2006 LCC Corps. FIRA2 comes with ABSOLUTELY NO WARRANTY;\n" +
                "This is free software, and you are welcome to redistribute it under The GNU General Public License (GPL)",
                "< < FIRA v2 > >",
                JOptionPane.INFORMATION_MESSAGE);
    }//GEN-LAST:event_aboutItemActionPerformed

    private void exitItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitItemActionPerformed
        // TODO add your handling code here:
        if (taskInProgress <= 0) {
            System.exit (0);
        } else {
            JOptionPane.showMessageDialog (this, "There is currently some running task(s).\n" +
                    "Exiting this application while task is running is prohibited.",
                    "ERROR: Task(s) running",
                    JOptionPane.WARNING_MESSAGE);
        }
    }//GEN-LAST:event_exitItemActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainFrame().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem aboutItem;
    private gui.AboutPanel aboutPanel1;
    private javax.swing.JMenuItem exitItem;
    private javax.swing.JMenu fileMenu;
    private gui.InjectPanel injectPanel1;
    private javax.swing.JMenuBar jMenuBar1;
    private gui.RetrievePanel retrievePanel1;
    private javax.swing.JTabbedPane tabPane;
    // End of variables declaration//GEN-END:variables
    
}
