/*
 * FIRA2 is a program to inject/hide a file into a standard bitmap file. 
 * It includes file compression and encryption as well.
 * Copyright (C) 2006 LCC Coprs
 * The author can be reached at aurora.lai@gmail.com
 *
 * This program is free software; you can redistribute it and/or modify it under 
 * the terms of the GNU General Public License as published by the Free Software 
 * Foundation; either version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT 
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS 
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with 
 * this program; if not, write to the Free Software Foundation, Inc., 
 * 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

/*
 * FILE: RetrievePanel.java
 * INHERITS: JPanel
 * PURPOSE: to create and layout all the GUI components 
 *          (for getting user inputs and executing the retrieval process)
 * AUTHOR: LCC Coprs
 * COMMENT: This file is generated by NetBean IDE 4.0, and is modified by the 
 *          specified author to customize some of the features
 *
 * Created on June 18, 2006, 2:55 PM
 */

package gui;

import javax.swing.JOptionPane;
import javax.swing.JFileChooser;
import javax.swing.Timer;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import sys.MyFile;
import sys.Password;
import sys.Task;
import sys.FileInjection;
import gui.custom.FileExtFilter;

/**
 *
 * @author  LCC Corps
 */
public class RetrievePanel extends javax.swing.JPanel {
    
    private MyFile data = null, carrier = null;
    private Task task = null;
    private Timer taskTimer = null;
    
    /** Creates new form RetrievePanel */
    public RetrievePanel() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    private void initComponents() {//GEN-BEGIN:initComponents
        fc = new gui.custom.MyFileChooser();
        jPanel1 = new javax.swing.JPanel();
        dataPanel = new javax.swing.JPanel();
        carrierPanel = new javax.swing.JPanel();
        carrierFileDisplay = new javax.swing.JTextField();
        browseCarrier = new javax.swing.JButton();
        pbPanel = new javax.swing.JPanel();
        pb = new javax.swing.JProgressBar();
        passwordPanel = new javax.swing.JPanel();
        passField = new javax.swing.JPasswordField();
        retrieve = new javax.swing.JButton();

        fc.getAccessibleContext().setAccessibleName("fc");
        fc.getAccessibleContext().setAccessibleParent(this);

        setLayout(new java.awt.BorderLayout());

        setPreferredSize(new java.awt.Dimension(290, 350));
        jPanel1.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        jPanel1.setName("injectPanel");
        dataPanel.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        dataPanel.setBorder(new javax.swing.border.EtchedBorder(javax.swing.border.EtchedBorder.RAISED));
        dataPanel.setToolTipText("No data file required");
        jPanel1.add(dataPanel, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 0, 290, 70));

        carrierPanel.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        carrierPanel.setBorder(new javax.swing.border.TitledBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED), "Select carrier file...", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11), new java.awt.Color(0, 0, 0)));
        carrierPanel.setToolTipText("Carrier file panel");
        carrierFileDisplay.setEditable(false);
        carrierFileDisplay.setFont(new java.awt.Font("Courier New", 0, 11));
        carrierFileDisplay.setText("No carrier file selected...");
        carrierFileDisplay.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                carrierFileDisplayActionPerformed(evt);
            }
        });

        carrierPanel.add(carrierFileDisplay, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 20, 220, 30));
        carrierFileDisplay.getAccessibleContext().setAccessibleName("carrierFileDisplay");
        carrierFileDisplay.getAccessibleContext().setAccessibleParent(this);

        browseCarrier.setAction(null);
        browseCarrier.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/images/browse.gif")));
        browseCarrier.setToolTipText("Click to browse carrier file");
        browseCarrier.setActionCommand("browseCarrier");
        browseCarrier.setName("browseCarrier");
        browseCarrier.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                browseCarrierActionPerformed(evt);
            }
        });

        carrierPanel.add(browseCarrier, new org.netbeans.lib.awtextra.AbsoluteConstraints(250, 20, 30, -1));

        jPanel1.add(carrierPanel, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 70, 290, 70));

        pbPanel.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        pbPanel.setBorder(new javax.swing.border.TitledBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED), "Task progress...", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11), new java.awt.Color(0, 0, 0)));
        pbPanel.setToolTipText("Task status panel");
        pb.setToolTipText("Display task status...");
        pb.setStringPainted(true);
        pbPanel.add(pb, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 20, 270, 30));

        jPanel1.add(pbPanel, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 210, 290, 60));

        passwordPanel.setLayout(new org.netbeans.lib.awtextra.AbsoluteLayout());

        passwordPanel.setBorder(new javax.swing.border.TitledBorder(new javax.swing.border.BevelBorder(javax.swing.border.BevelBorder.RAISED), "Enter a password...", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Tahoma", 1, 11), new java.awt.Color(0, 0, 0)));
        passwordPanel.setToolTipText("Password panel");
        passField.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                startRetrieve(evt);
            }
        });
        passField.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusGained(java.awt.event.FocusEvent evt) {
                selectAllOnFocus(evt);
            }
        });

        passwordPanel.add(passField, new org.netbeans.lib.awtextra.AbsoluteConstraints(10, 18, 220, 30));

        jPanel1.add(passwordPanel, new org.netbeans.lib.awtextra.AbsoluteConstraints(0, 140, 290, 70));

        retrieve.setFont(new java.awt.Font("Courier New", 1, 11));
        retrieve.setIcon(new javax.swing.ImageIcon(getClass().getResource("/gui/images/retrieve.gif")));
        retrieve.setMnemonic('r');
        retrieve.setText("Retrieve");
        retrieve.setToolTipText("Click to start file retrieval");
        retrieve.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        retrieve.setIconTextGap(10);
        retrieve.setName("retrieve");
        retrieve.setPreferredSize(new java.awt.Dimension(100, 60));
        retrieve.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        retrieve.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                retrieveActionPerformed(evt);
            }
        });

        jPanel1.add(retrieve, new org.netbeans.lib.awtextra.AbsoluteConstraints(100, 280, -1, -1));
        retrieve.getAccessibleContext().setAccessibleName("retrieve");
        retrieve.getAccessibleContext().setAccessibleParent(this);

        add(jPanel1, java.awt.BorderLayout.CENTER);

    }//GEN-END:initComponents

    
    /*
     * Action listener for the JPasswordField passField
     */
    private void startRetrieve(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_startRetrieve
        // TODO add your handling code here:
        retrieve.doClick ();
    }//GEN-LAST:event_startRetrieve

    
    /*
     * Focus listener for the JPasswordField passField
     */
    private void selectAllOnFocus(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_selectAllOnFocus
        // TODO add your handling code here:
        passField.selectAll ();
    }//GEN-LAST:event_selectAllOnFocus
        
    
    /*
     * METHOD: setControlEnabled ()
     * PURPOSE: to enable/disable all the control component 
     *          (JButton and JTextField) for the RetrievePanel
     * IMPORT: flag to enable/disable the control
     * EXPORT: none
     */
    private void setControlEnabled (boolean b) {
        retrieve.setEnabled (b);
        passField.setEnabled (b);
        browseCarrier.setEnabled (b);
    }

    
    /* 
     * METHOD: retrieveActionPerformed()
     * PURPOSE: to provide the action listener interface for the 'Retrieve button'
     *          This function will execute all the file retrieval process, 
     *          including getting and validating all the data from the input fields,
     *          and actually executing the file retrieval process
     * IMPORT: ActionEvent object
     * EXPORT: none
     */
    private void retrieveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_retrieveActionPerformed
        // TODO add your handling code here:
        Password pass = null;
        
        // no carrier file selected
        if (carrier == null) {
            JOptionPane.showMessageDialog (this, 
                    "Please select a carrier file to continue.",
                    "No carrier file selected.",
                    JOptionPane.ERROR_MESSAGE);
            return;
        }

        // check password validity
        pass = new Password ((new String (passField.getPassword ())).getBytes ());
        if (!pass.isValid()) {
            JOptionPane.showMessageDialog (this, 
                    "Please enter a password with 2-20 characters.",
                    "Invalid password.",
                    JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        // if file is purposely deleted after selecting it
        if (!carrier.exists()) {
            JOptionPane.showMessageDialog (this, 
                    "Selected carrier file does not exist.\n" +
                    "Please select a carrier file again.",
                    "Carrier file does not exist.",
                    JOptionPane.ERROR_MESSAGE);
            return;
        }
        
        // create all required objects
        task = new Task (data, carrier, pass, Task.RETRIEVE);
        TimerListener tlis = new TimerListener (task);
        taskTimer = new Timer (500, tlis);
        tlis.setTimer (taskTimer);
        
        // start all the tasks
        MainFrame.taskInProgress++;
        taskTimer.start ();
        task.start ();
        setControlEnabled (false);
    }//GEN-LAST:event_retrieveActionPerformed

    private void carrierFileDisplayActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_carrierFileDisplayActionPerformed
        // TODO add your handling code here:
    }//GEN-LAST:event_carrierFileDisplayActionPerformed

    
    /*
     * METHOD: browseCarrierActionPerformed ()
     * PURPOSE: to implement the action listener interface for the button 
     *          for browsing the carrier file
     * IMPORT: ActionEvent object (as required)
     * EXPORT: none
     */
    private void browseCarrierActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_browseCarrierActionPerformed
        // TODO add your handling code here:
        int selection;
        
        fc.resetChoosableFileFilters();
        fc.setAcceptAllFileFilterUsed (false);
        fc.addChoosableFileFilter (new FileExtFilter ("bmp", "Bitmap file (*.bmp)"));
        selection = fc.showOpenDialog (null);
        
        if (selection == JFileChooser.APPROVE_OPTION) {
            carrier = new MyFile (fc.getSelectedFile ());
            carrierFileDisplay.setText (carrier.getName ());
        }
    }//GEN-LAST:event_browseCarrierActionPerformed
    
    
    /*
     * INNER CLASS: TimerListener
     * IMPLEMENTS: ActionListener
     * PURPOSE: to implement an action listener class for the Timer object, used 
     *          for control and update the progress bar object
     */
    class TimerListener implements ActionListener
    { 
        // progress bar waits when it move faster than the actual task
        private final int PB_WAIT_AT = 98; 
        
        private float status = 0;
        private Timer timer = null;
        private Task task;
       
        public TimerListener (Task task)
        {
            this.task = task;
        }
        
        /*
         * METHOD: setTimer ()
         * PURPOSE: to set the Timer object so that its speed (delay time) can 
         *          be changed
         * IMPORT: Timer object
         * EXPORT: none
         */
        public void setTimer (Timer t)
        {
            timer = t;
        }
        
        /*
         * METHOD: actionPerformed ()
         * PURPOSE: to implement the action to be performed on each trigger of 
         *          the Timer object. Used to update the progress bar
         * IMPORT: ActionEvent object (as required)
         * EXPORT: none
         */
        public void actionPerformed (ActionEvent e)
        {
            // approximation of the speed of the injection task
            float speed = (float) ((10*FileInjection.NORM_RETRIEVE_SPEED * 30.0*1024)/carrier.length());

            if (!task.isComplete ()) {
                // shortcut way to round up
                status = status + (speed + 0.5f);

                // 'pause' the progress bar if it almost reaching 100%, but 
                // the actual task not yet finished
                if (status > PB_WAIT_AT)
                    status = PB_WAIT_AT;
                        
                pb.setValue ((int)status);
            } else {
                // if task is completed with error
                // The only error at this stage is that the carrier file does not 
                // contain any hidden file or the entered password is incorrect 
                if (task.hasError ()) {
                   JOptionPane.showMessageDialog (null,
                           "Unable to retrieve any hidden file from the selected file.\n" +
                           "Please ensure tha:\n" + 
                           "1. Correct password has been entered, and\n" +
                           "2. The selected file contains a hidden file.",
                           "File retrieval failed.", 
                            JOptionPane.WARNING_MESSAGE);
                    timer.stop ();
                    MainFrame.taskInProgress--;
                    setControlEnabled (true);
                } else {
                    // speed up progressbar, by decreasing the Timer delay time, 
                    // rather than by increase the value of speed, because 
                    // 'Human does not like numbers to jump around' 
                    if (timer != null)
                        timer.setDelay ((int)(500/(PB_WAIT_AT - pb.getValue () + 5)));
                    
                    // shortcut way to round up
                    status += (speed + 0.5f);
                    pb.setValue ((int)status);
 
                    // task completed successfully
                    if (status >= 100) {
                        JOptionPane.showMessageDialog (null, 
                            "\"" +task.getDataFile().getName() +"\" has been\n" +
                            "successfully retrieved from \"" +carrier.getName () +"\".", 
                            "File retrieval completed.",
                            JOptionPane.INFORMATION_MESSAGE);
                        timer.stop ();
                        pb.setValue (0);
                        MainFrame.taskInProgress--;
                        setControlEnabled (true);
                    }   
                }
            }
        }
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton browseCarrier;
    private javax.swing.JTextField carrierFileDisplay;
    private javax.swing.JPanel carrierPanel;
    private javax.swing.JPanel dataPanel;
    private gui.custom.MyFileChooser fc;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPasswordField passField;
    private javax.swing.JPanel passwordPanel;
    private javax.swing.JProgressBar pb;
    private javax.swing.JPanel pbPanel;
    private javax.swing.JButton retrieve;
    // End of variables declaration//GEN-END:variables
    
}
